import Foundation
import Metal
import MetalKit

class VexilMain : Renderer {
	
    var _model : VexilModel!
    var _modelGirl : VexilModel!
	var _touch: Bool = false
	
	override init?(metalKitView: MTKView) {
		super.init(metalKitView:metalKitView)
		_bgColor = MTLClearColor(red: 0.3, green: 0.6, blue: 1.0, alpha: 1)
        _model = loadModel(model: LoadModel(device:_device,fileName:"CheckGirl")!)
    }
	
	override func draw(in view: MTKView) {
		modelMove()
		
		_eye = simd_float3(0,150,-500)
		_center = simd_float3(0,100,0)
		_up = simd_float3(0,1,0)
		
		super.draw(in: view)
	}
	
	func modelMove()
	{
		if _touch {
			let radians:Float = Transforms.radians_from_degrees(_model._rotation.y)
			_model._translation.x += sin(radians) * 2
			_model._translation.z -= cos(radians) * 2
		} else {
            _model._rotation.y += 1
			if _model._rotation.y >= 360 {
				_model._rotation.y -= 360
			}
		}
	}
	
	func touchesBegan(_ touches: Set<UITouch>, with event: UIEvent?)  {
//        let touch = touches.first
//        let loc = touch!.location(in:_mtkView)
//        if ( _model.mousePick(
//            x:loc.x,y:loc.y,
//            width:_viewportSize!.width,height:_viewportSize!.height,
//            projection:_projectionMatrix) )
//        {
//            _model.stopAnimation()
//        } else {
            _model.playAnimation(animation: 1, loop: true)
//        }
        _touch = true
	}

	func touchesMoved(_ touches: Set<UITouch>, with event: UIEvent?)  {
	}
	
	func touchesEnded(_ touches: Set<UITouch>, with event: UIEvent?)  {
		_touch = false
        _model.playAnimation(animation: 0, loop: true)
	}
}
